#! /usr/bin/perl

use CGI::Carp qw(fatalsToBrowser);
use strict;
use Image::Magick;
use CGI;
use Data::Dumper;

#open(PROGRESS, ">", "/tmp/progress.txt") or warn "Can't open progress log.";
#print PROGRESS "Got to " . __LINE__ . "<br>\n"; $|=1; $|=0;


######################
# Get CGI Parameters #
######################
my $cgi = new CGI;
my $submit = $cgi->param('submission');
my $unique = $ENV{UNIQUE_ID} || int(rand(2**30));
my $name = $cgi->param("name");
my $LEDcolor = $cgi->param("color");

open(OUTPUT, ">", "compare_${unique}.html");
print "Location: compare_${unique}.html\n\n";

print OUTPUT <<EOHTML;
<html>
<head>
<link rel="stylesheet" type="text/css" href="style.css" />
<style>
    IMG { 

    }
</style>
</head>
<body>
<div class="header" style="display: none;">
<img id="logo" src="/graphics/agile_logo.png" width="228" height="211" />
<h1>Graphics Creation Tool</h1>
</div>
<div style="display: none; position: absolute; top: 4; right: 4; margin: 0;"><a style="width: 80px;" href="./" class="button">New Graphic</a></div>

EOHTML
$|=1;
if($submit eq 'Create Graphic' || $submit eq 'Create Animated Graphic') {
    my $err;
    my $img = Image::Magick->new;
    my (@blobs, @times, @delays);

    my $filename = $cgi->param('image');
    my $fh = $cgi->upload('image');
    
    if(!$fh) {
	print OUTPUT "<p><b>Error:</b> You must upload an image file.</p>\n";
	exit(0);
    }

    #######################################################
    # Convert the image to the correct Size and Bit Depth #
    #######################################################
    $err = $img->Read(file=>$fh);
    if($err) {
	warn $err;
	write_to_file_and_open($filename, $fh, $img);
    }
    if(!$img) {
	print OUTPUT "<p><b>Error:</b> Unable to read image. Please ensure that it is in one of the supported formats and that it contains no errors.</p>";
    }
    #print " "; # to keep the browser alive
    $err = $img->Set(matte => 'false', compression => 'none'); # transparency == bad, compression == bad
    warn $err if $err;
    #print " "; # to keep the browser alive
    $err = $img->Resize(width=>48, height=>27); # All Current Message boards are 48x27 as of 2004-06-04
    warn $err if $err;
    #print " "; # to keep the browser alive

    ######################
    # Write the Original #
    ######################
    $err = $img->Set(magick => 'RGB');
    warn $err if $err;
    my ($original_image) = $img->ImageToBlob();
    my @original = unpack("C*", $original_image);
    my @base;
    my $o;
    foreach my $i (0..26) {
	$o .= pack("C[432]", 0); 
	foreach my $j (0..47) {
	    $o .= pack("CCC", 0, 0, 0);
	    $o .= pack("CCC", $original[3*48*$i + 3*$j], $original[3*48*$i + 3*$j + 1], $original[3*48*$i + 3*$j + 2]);
	    $o .= pack("CCC", 0, 0, 0);
	}
	$o .= pack("C[432]", 0); 
    }

    my $oimg = Image::Magick->new(magick => "RGB");
    $err = $oimg->Set(size=>'144x81', depth=>8);
    warn $err if $err;
    $err = $oimg->BlobToImage($o);
    warn $err if $err;
    
    $err = $oimg->Set(magick=>'PNG');
    warn $err if $err;
    
    $err = $oimg->Write("compare_${unique}_original.png");
    warn $err if $err;
    print OUTPUT qq{<div style="margin: 12px;">Original<br /> <img src="compare_${unique}_original.png" /></div>\n};


    ########################
    # Now Space things out #
    ########################
    use integer;
    $err = $img->Set(magick => 'GRAY', depth =>8, compression => 'none', dither=>'true');
    warn $err if $err;
    my ($original) = $img->ImageToBlob();
    my @original = unpack("C*", $original);
    my @base;
    my $new;
    foreach my $i (0..26) {
	$new .= pack("C[144]",0); 
	foreach my $j (0..47) {
	    $new .= pack("CCC", 0, $original[48*$i + $j], 0);
	}
	$new .= pack("C[144]",0); 
    }

    ###################
    # Set up the Mask #
    ###################
    my %mask = (8 => 0xff,
		6 => 0xfb,
		4=> 0xf0,
		3 => 0xe0,
		2 => 0xc0,
		1 => 0x80);
#    foreach my $k (keys %mask) {
#	$mask{$k} = pack("C", $mask{$k});
#    }

    my $rowcounter;
    foreach my $depth (8, 6, 4, 3, 2, 1) {
	# Create the Image depth
	no integer;
	my $mask = $mask{$depth};
#	my $scale = 255/(255 & $mask);
	my $trans = 255 - (255 & $mask);
	my ($bits, %values, $logbits, %logvalues);
	foreach my $byte (unpack("C*", $new)) {
	    $byte = int((($byte&$mask)?$trans:0) + ($byte & $mask));
	    $bits .= pack("C", $byte);
	    $values{$byte}++;

	    my $scale = log(1 + (1.71828 * ( $byte/255  )));
	    $byte = pack("C", int(255*$scale));
	    $logbits .= $byte;
	    $logvalues{$byte}++;
	}
	#########################
	# With Linear Intensity #
	#########################
	my $values = scalar(keys %values);
	my $img = Image::Magick->new(magick=>'GRAY');
	$err = $img->Set(depth=>'8', size=>'144x81', compression=>'none');
	warn $err if $err;
	$err = $img->BlobToImage($bits);
	warn $err if $err;
	$img->Set(magick=>'PNG');
	$err = $img->Set(depth => 24);
	warn $err if $err;

	$img->Write("compare_${unique}_$depth.png");
	print OUTPUT qq{<div style="float: left; margin: 12px; text-align: center;"><div>$depth bits, $values values</div> <img src="compare_${unique}_$depth.png" /></div>\n};

	##############################
	# With Logarithmic Intensity #
	##############################
	my $values = scalar(keys %logvalues);
	my $img = Image::Magick->new(magick=>'GRAY');
	$err = $img->Set(depth=>'8', size=>'144x81', compression=>'none');
	warn $err if $err;
	$err = $img->BlobToImage($logbits);
	warn $err if $err;
	$img->Set(magick=>'PNG');
	$err = $img->Set(depth => 24);
	warn $err if $err;

	$img->Write("compare_${unique}_${depth}_log.png");
	print OUTPUT qq{<div style="float: left; margin: 12px; text-align: center;"><div>$depth bits (log), $values values</div> <img src="compare_${unique}_${depth}_log.png" /></div>\n};

	if($rowcounter == 1) {
	    print OUTPUT qq{<div style="clear: both;">&nbsp;</div>\n};
	}
	$rowcounter = ($rowcounter + 1) % 2;
    }

    print OUTPUT <<EOHTML;
</body>
</html>
EOHTML
} else {
    print OUTPUT qq{<head></head><body><h1>Error: Unkown Submission</h1><p>You have supplied an unrecognized CGI parameter. Please use the form normally or report this error.</p></body></html>\n};
    exit(0);
}

close(OUTPUT);
print "\n";

#################################
# Clear out the Old Image Files #
#################################
my $time = time();
foreach my $file (glob("compare_*.png"), glob("compare_*.html")) {
    next; # don't clean out right now
    # Note: currently cleared after 24 hours, maybe longer would be better
    if((stat($file))[9] + 86400 < $time) {
	unlink($file);
    }
}

sub write_to_file_and_open() {
    my ($filename, $fh, $img) = @_;

    $filename =~ m{([^/ \\ \s \.]+)$ }x;
    my $fn = $1;
    open(H, ">", "$fn");
    print H <$fh>;
    close(H);
    my $err = $img->Read(filename=> $fn);
    warn $err if $err;
    unlink("foo.gif");

    return;
}

#close(PROGRESS);
